import Flutter
import UIKit
import PDFKit

public class SwiftZigzagReaderPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "zigzag_reader", binaryMessenger: registrar.messenger())
    let instance = SwiftZigzagReaderPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    DispatchQueue.global(qos: .default).async {
        if call.method == "getPDFText" {
          let args = call.arguments as! NSDictionary
          let path = args["path"] as! String
          var pdfText = ""

            if let pdf = PDFDocument(url: URL(fileURLWithPath: path)) {
            let pageCount = pdf.pageCount
          
              for i in 1 ..< pageCount {
                  let pageContent = pdf.page(at: i)!.string!
                  pdfText += pageContent
              }
                DispatchQueue.main.sync {
                  result(pdfText);
                }
            }
            else
            {
                DispatchQueue.main.sync {
                  result(FlutterError(code: "NO_PATH",
                  message: "Path cannot be found",
                  details: nil))
                }
            }
        }       
        else {
                DispatchQueue.main.sync {
                  result(FlutterMethodNotImplemented)
                }
        }
      }
  }
}
